#ifndef __INC_LINKAGE_H
#define __INC_LINKAGE_H

#include<auth.h>
#include<encryption.h>
#include<iohandler.h>
#include<bocomreg.h>
#include<dll_load.h>
#include<commnet.h>
#include<commandloop.h>
#include<functions.h>
#include<pviewer.h>
#include<plugins.h>

typedef struct __plugin_version {
	char *svFilename;
	char *svDescription;
	WORD wVersionLo;
	WORD wVersionHi;
	WORD wBOVersionLo;
	WORD wBOVersionHi;
	DWORD dwFlags;
} PLUGIN_VERSION;

#define PVF_SERVER 2
#define PVF_CLIENT 1

// This is only here until we get a header file for it
typedef int (TYPEOF_ClientMenu)(HWND hParent);
typedef int (TYPEOF_RegisterClientMenu)(LPCSTR szCategory, LPCSTR szComName, TYPEOF_ClientMenu *pProc);
typedef int (TYPEOF_UnregisterClientMenu)(LPCSTR szCategory, LPCSTR szComName);

typedef struct __plugin_linkage {
	// Generic
	WORD wBO2KVerLo;
	WORD wBO2KVerHi;
	void *pBaseAddress;

	// COMMANDLOOP
	BOOL *pbEradicate;
	BOOL *pbBO2KFinished;
	BOOL *pbRestart;
	char *svRestartProcess;
	char *svStartupOptions;
	
	CAuthSocket **ppCommSock;
	int *pnCommCount;
	CAuthSocket **ppConnSock;
	int *pnConnCount;
	
	CEncryptionHandler				*pEncryptionHandler;
	CIOHandler						*pIOHandler;
	CAuthHandler					*pAuthHandler;
	
	// AUTH
	TYPEOF_ConnectAuthSocket		*pConnectAuthSocket;
	TYPEOF_ListenAuthSocket			*pListenAuthSocket;
	INTERACTIVE_LISTEN				*pInteractiveListen;
	INTERACTIVE_CONNECT				*pInteractiveConnect;
	
	// BOCOMREG
	BO_CMD_HANDLER *command_handler_table;
	BO_CMD_DESC *command_description_table;
	TYPEOF_RegisterCommand			*pRegisterCommand;
	TYPEOF_UnregisterCommand		*pUnregisterCommand;
	TYPEOF_RegisterClientMenu		*pRegisterClientMenu;
	TYPEOF_UnregisterClientMenu		*pUnregisterClientMenu;
	TYPEOF_DispatchCommand			*pDispatchCommand;

	// COMMNET
	TYPEOF_BreakDownCommand			*pBreakDownCommand;
	TYPEOF_BuildCommandRequest		*pBuildCommandRequest;
	TYPEOF_BuildCommandReply		*pBuildCommandReply;
	TYPEOF_FreeCommandMemory		*pFreeCommandMemory;
	TYPEOF_IssueAuthCommandRequest	*pIssueAuthCommandRequest;
	TYPEOF_IssueAuthCommandReply	*pIssueAuthCommandReply;
	
	// PVIEWER
	TYPEOF_CreateProcListSnapshot	*pCreateProcListSnapshot;
	TYPEOF_DestroyProcListSnapshot	*pDestroyProcListSnapshot;
	
	// PLUGIN
	TYPEOF_AddPlugin				*pAddPlugin;
	TYPEOF_DebugPlugin				*pDebugPlugin;
	TYPEOF_RemovePlugin				*pRemovePlugin;
	TYPEOF_GetPlugin				*pGetPlugin;

	// DLL_LOAD
	TYPEOF_GetDLLHandle				*pGetDLLHandle;
	TYPEOF_GetDLLFileName			*pGetDLLFileName;
	TYPEOF_GetDLLProcAddress		*pGetDLLProcAddress;
	TYPEOF_SetDLLProcAddress		*pSetDLLProcAddress;
	TYPEOF_ResetDLLProcAddress		*pResetDLLProcAddress;
	TYPEOF_LoadDLLFromImage			*pLoadDLLFromImage;
	TYPEOF_LoadDLLEx				*pLoadDLLEx;
	TYPEOF_LoadDLL					*pLoadDLL;
	TYPEOF_FreeDLL					*pFreeDLL;

	// OPERATING SYSTEM SPECIFIC STUFF
	union {
		struct _win {
			BOOL bIsWinNT;
	
			// FUNCTIONS
			CREATESNAPSHOT pCreateToolhelp32Snapshot; 
			MODULEWALK  pModule32First; 
			MODULEWALK  pModule32Next; 
			PROCESSWALK pProcess32First; 
			PROCESSWALK pProcess32Next; 
			THREADWALK  pThread32First; 
			THREADWALK  pThread32Next; 
			REGSERVICEPROC pRegisterServiceProcess;
			CREATEREMOTETHREAD pCreateRemoteThread;
			VIRTUALALLOCEX pVirtualAllocEx;
			VIRTUALFREEEX pVirtualFreeEx;
			VIRTUALQUERYEX pVirtualQueryEx;
			VIRTUALPROTECTEX pVirtualProtectEx;
			
			ENUMPASSWORD pWNetEnumCachedPasswords;
			WNETCLOSEENUM pWNetCloseEnum;
			WNETENUMRESOURCE pWNetEnumResource;
			WNETOPENENUM pWNetOpenEnum;
			WNETCANCELCONNECTION2 pWNetCancelConnection2;
			WNETADDCONNECTION2 pWNetAddConnection2;
			
			LMS_NETSESSIONENUM pLMSNetSessionEnum;
			LMS_NETSHAREENUM pLMSNetShareEnum;
			LMS_NETSHAREDEL pLMSNetShareDel;
			LMS_NETSHAREADD pLMSNetShareAdd;
			LMS_NETAPIBUFFERFREE pLMSNetApiBufferFree;
			
			SVR_NETSESSIONENUM pSVRNetSessionEnum;
			SVR_NETSHAREENUM pSVRNetShareEnum;
			SVR_NETSHAREDEL pSVRNetShareDel;
			SVR_NETSHAREADD pSVRNetShareAdd;
			
			REGSETKEYSECURITY pRegSetKeySecurity;
			SETSECURITYDESCRIPTORDACL pSetSecurityDescriptorDacl;
			GETACE pGetAce;
			ADDACCESSALLOWEDACE pAddAccessAllowedAce;
			INITIALIZEACL pInitializeAcl;
			INITIALIZESECURITYDESCRIPTOR pInitializeSecurityDescriptor;
			GETLENGTHSID pGetLengthSid;
			LOOKUPACCOUNTNAME pLookupAccountName;
			LOOKUPACCOUNTSID pLookupAccountSid;
			GETSECURITYDESCRIPTORDACL pGetSecurityDescriptorDacl;
			GETSECURITYDESCRIPTORGROUP pGetSecurityDescriptorGroup;
			GETSECURITYDESCRIPTOROWNER pGetSecurityDescriptorOwner;
			OPENPROCESSTOKEN pOpenProcessToken;
			LOOKUPPRIVILEGEVALUE pLookupPrivilegeValue;
			ADJUSTTOKENPRIVILEGES pAdjustTokenPrivileges;
			REGGETKEYSECURITY pRegGetKeySecurity;
			
			OPENSCMANAGER pOpenSCManager;
			CREATESERVICE pCreateService;
			CLOSESERVICEHANDLE pCloseServiceHandle;
			OPENSERVICE	pOpenService;
			STARTSERVICECTRLDISPATCHER pStartServiceCtrlDispatcher;
			REGISTERSERVICECTRLHANDLER pRegisterServiceCtrlHandler;
			SETSERVICESTATUS pSetServiceStatus;
			DELETESERVICE pDeleteService;
			GETSERVICEDISPLAYNAME pGetServiceDisplayName;
			STARTSERVICE pStartService;
		} win;
	};
} PLUGIN_LINKAGE;

#endif